library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity adder is
	port(
		clk: IN STD_LOGIC;
		rst: IN STD_LOGIC;
		data_out: OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
		x : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
		y : IN STD_LOGIC_VECTOR(3 DOWNTO 0));
end adder;

architecture behavioral of adder is
	component add_modul
	port(
		x,y : IN STD_LOGIC;
		z : OUT STD_LOGIC;
		carry_in : IN STD_LOGIC;
		carry_out : OUT STD_LOGIC);
	end component;

	component reg_modul
	generic (
		size : INTEGER := 2);
	port(
		data_in : IN STD_LOGIC_VECTOR(size-1 DOWNTO 0);
		data_out : OUT STD_LOGIC_VECTOR(size-1 DOWNTO 0);
		clk : IN STD_LOGIC;
		rst : IN STD_LOGIC);
	end component;

	signal carry: STD_LOGIC_VECTOR(3 DOWNTO 0);
	signal z: STD_LOGIC_VECTOR(3 DOWNTO 0);
	
begin

	sest0:add_modul
	port map
	(
		x => x(0),
		y => y(0),
		z => z(0),
		carry_in => '0',
		carry_out => carry(0)
	);

	sest1:add_modul
	port map
	(
		x => x(1),
		y => y(1),
		z => z(1),
		carry_in => carry(0),
		carry_out => carry(1)
	);

	sest2:add_modul
	port map
	(
		x => x(2),
		y => y(2),
		z => z(2),
		carry_in => carry(1),
		carry_out => carry(2)
	);

	sest3:add_modul
	port map
	(
		x => x(3),
		y => y(3),
		z => z(3),
		carry_in => carry(2),
		carry_out => carry(3)
	);

	reg4bit:reg_modul
	generic map
	(
		size => 4
	)
	port map
	(
		data_in => z,
		data_out => data_out,
		clk => clk,
		rst => rst
	);

end behavioral;

