library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity reg_modul is
	generic(
		size : INTEGER := 2);
	port(
		data_in : IN STD_LOGIC_VECTOR(size-1 DOWNTO 0);
		data_out : OUT STD_LOGIC_VECTOR(size-1 DOWNTO 0);
		clk : IN STD_LOGIC;
		rst : IN STD_LOGIC);
end reg_modul;

architecture behavioral of reg_modul is
	signal q : STD_LOGIC_VECTOR(size-1 DOWNTO 0);
begin
	data_out <= q;
	
	process (clk)
	begin
		if (rising_edge(clk)) then
			if (rst = '1') then			-- asinhroni reset
				q <= (others => '0');	-- celemu vektorju priredimo vrednost '0'
			else				
				q <= data_in;
			end if;
		end if;

	end process;

end behavioral;

		
